// -*- coding: iso-8859-1-unix -*-

#ifndef TECGRAF_OPENBUS_DATASERVICE_PROJECT_PROJECT_DATA_VIEW_IMPL_H
#define TECGRAF_OPENBUS_DATASERVICE_PROJECT_PROJECT_DATA_VIEW_IMPL_H

#include "decl.hpp"
#include "stubs/project.h"

namespace tecgraf { namespace openbus { namespace data_service {
namespace project { namespace v1_02 {

namespace dataservice_core = ::tecgraf::openbus::data_service::core::v1_02;

/** 
 * @brief Classe que implementa o ProjectDataView valuetype.
 */
class OPENBUS_DS_PROJECT_DECL ProjectDataViewImpl : 
  public virtual OBV_tecgraf::openbus::data_service::project::v1_02::ProjectDataView,
  public virtual CORBA::DefaultValueRefCountBase
{
public:
  ProjectDataViewImpl();
  virtual ~ProjectDataViewImpl();

  ProjectDataViewImpl(
    const dataservice_core::DataKey &_itfld_fKey,
    const char *_itfld_fOwner,
    const char *_itfld_fDescription,
    const char *_itfld_fPath,
    const char *_itfld_fSoftware,
    CORBA::LongLong _itfld_fSize,
    const StringSeq &_itfld_fReadingUsers,
    const StringSeq &_itfld_fWritingUsers,
    dataservice_core::TimeStamp _itfld_fCreationDate,
    dataservice_core::TimeStamp _itfld_fModificationDate
    );
  virtual dataservice_core::DataKey *getKey();
  virtual char *getInterfaceName();

  virtual CORBA::ValueBase *_copy_value();
};
                    
/** 
 * @brief Classe responsvel por construir instancias de ProjectDataView. 
 */
class OPENBUS_DS_PROJECT_DECL ProjectDataViewFactory
  : public virtual CORBA::ValueFactoryBase
{
public:
  virtual ~ProjectDataViewFactory();
  virtual CORBA::ValueBase *create_for_unmarshal();
};
} } } } }

#endif
